(***********************************************************************)
(*                                                                     *)
(*                        Caml examples                                *)
(*                                                                     *)
(*            Pierre Weis                                              *)
(*                                                                     *)
(*                        INRIA Rocquencourt                           *)
(*                                                                     *)
(*  Copyright (c) 1994-2015, INRIA                                     *)
(*  All rights reserved.                                               *)
(*                                                                     *)
(*  Distributed under the BSD license.                                 *)
(*                                                                     *)
(***********************************************************************)

(* $Id: token.mli,v 1.5 2015/03/27 19:25:31 weis Exp $ *)

#open "stream";;

type token_type =
  | IDENT of string | INT of int | OP of string
  | BSLASH | DOT | ELSE | EQUAL | FI | IF | LET | LPAREN | RPAREN | SEMICOL
  | THEN
;;

value next_token : char stream -> token_type;;
value reset_lexer : char stream -> unit;;
value token_name : token_type -> string;;
